Subject: bug#14233: 24.3; Don't constrain frame size to character multiples

From: Eli Zaretskii <[email-masked]>
Date: Sat, 20 Apr 2013 14:32:40 +0300

> Date: Sat, 20 Apr 2013 13:01:52 +0200
> From: martin rudalics <[email-masked]>
> CC: [email-masked], [email-masked], [email-masked]
> 
>  > I think what's important is to have a way of resizing a specific
>  > window to a specific pixel-size.  What happens to other windows as
>  > result is less important.
> 
> There are some subtle issues.  Suppose I now have two adjacent windows
> each 200 pixels high.  I have to give these windows suitable line
> heights.  Giving them both either 12 lines or 13 lines will break
> calculations based on the return values of `window-edges'.

What will break?  Is it possible to avoid the breakage without
imposing arbitrary restrictions on pixel dimensions of windows?

>  > The fact that the fringes and the scroll bar are excluded from the
>  > dimensions of the text area sounds correct to me.  Otherwise, it would
>  > be confusing to have non-text portions included in the text area
>  > dimensions, and could lead to subtle bugs due to this mental
>  > dissonance.
> 
> But on Windows the toolbar is included in the frame's text height and
> sometimes even the menubar is.  And the display margins, whether outside
> or inside the fringes, are part of the text width.  Aren't these mental
> dissonances as well?

No, because a tool bar is just another window (albeit a special one).
As for display margins, they do display text, don't they?

It could be that the fringes are included because of the display
margins outside the fringes configuration (which is the default).  If
that is the case, then perhaps we should leave this alone, although it
feels wrong.

>  >> - The heights of the tool and menubar are specified in lines.  Do we
>  >>    intend to change that to pixels?
>  >
>  > I don't think so: clipping the displayed stuff in these "windows"
>  > doesn't make sense, IMO.  IOW, a tool bar whose icons are only
>  > partially visible is ugly, and I'm not aware of a single application
>  > that does that.
> 
> I had in mind the case where toolbar elements and borders asked for some
> arbitrary pixel height.  IIUC we currently do some rounding there to fit
> them into screen line multiples.  Such rounding would not be needed any
> more.

Well, in that case, just keep this in the wishlist, instead of
rejecting ;-)